import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.JComponent;
import javax.swing.*;
import java.lang.String;

public class RoadApplet extends JApplet implements Runnable, ActionListener
{
  private RoadCanvas canvas;
  private Thread     runner;
  public  int        count;
  public  Label      jlGen;
  public  Label      jlsd;
  public  Label      jlar;
  public  Label      jlmd;
  public  Label      jler;
  public  Label      jllr;

  private Scrollbar slowdown;
  private Scrollbar arrival;
  private Scrollbar changelane;
  private Scrollbar lambda;
  private Scrollbar enterRate;
  private Scrollbar leaveRate;
  private Button    jbStart;
  private Button    jbStop;
  private JRadioButton jbDeterministic;
  private JRadioButton jbUndeterministic;
  private ButtonGroup  jbGroup;

  private Graphics bg = null;
  private Panel ctrlMain;
  private Panel ctrlPanel;
  private Panel ctrlPanel1;
  private float timeStep = 1000;
  //private final String SpaceLabel = "Space";
  //private final String[] TimeLabel = {"T","i","m","e"};

  public final static double DELTAX  = 7.5;
  protected volatile boolean threadSuspended;

  public RoadApplet(){}

  public void init()
  {
    count = 0;
    ctrlPanel  = new Panel();
    ctrlPanel  = addPanel();
    ctrlPanel1 = new Panel();
    ctrlPanel1 = addPanel1();
    canvas = new RoadCanvas(getArrival(), DELTAX);

    //this is the parent panel
    Panel p = new Panel();
    p.setSize(500,350);

    Panel p1 = new Panel();
    p1.setSize(350,350);
    p1.setLayout(new BorderLayout());
    canvas.setSize(350,350);
    p1.add(canvas);

    ctrlMain = new Panel();
    ctrlMain.setSize(150, 350);
    ctrlMain.setLayout(new BorderLayout());

    Panel p3 = new Panel();
    p3.setSize(150, 100);
    p3.setLayout(new GridLayout(3,1));
    jlGen = new Label("generation# ");

    jbDeterministic = new JRadioButton("Stochastic", true);
    jbDeterministic.setActionCommand("deterministic");
    jbUndeterministic = new JRadioButton("deterministic");
    jbUndeterministic.setActionCommand("undeterministic");
    jbGroup = new ButtonGroup();
    jbGroup.add(jbDeterministic);
    jbGroup.add(jbUndeterministic);

    p3.add(jlGen);
    p3.add(jbDeterministic);
    p3.add(jbUndeterministic);
    ctrlMain.add(p3, BorderLayout.NORTH);
    ctrlMain.add(ctrlPanel, BorderLayout.CENTER);


    jbStop = new Button("PAUSE");
    jbStop.setActionCommand("PAUSE");
    ctrlMain.add(jbStop, BorderLayout.SOUTH);

    //add actionListener to buttons.
    jbDeterministic.addActionListener(this);
    jbUndeterministic.addActionListener(this);
    jbStop.addActionListener(this);

    p.setLayout(new FlowLayout());
    p.add(p1);
    p.add(ctrlMain);
    this.getContentPane().setLayout(new FlowLayout());
    this.getContentPane().add(p);

  }

  public void run()
  {
    long startTime, currentTime;
    startTime = System.currentTimeMillis();


    while(true)
    {
      if(jbDeterministic.isSelected())
      {
        canvas.update(getSlowdown(), getArrival(),
                         getLambda(), getChangeLane());
      }
      else
        canvas.update(getEnterRate(), getLeaveRate());

      count++;
      jlGen.setText("Current Step: " + count);

      try {
        //this technique for some reason stalls for about 10
        //seconds at start time.
        //startTime += timeStep;
        //currentTime = System.currentTimeMillis();
        //Thread.sleep(Math.max(0, startTime - currentTime) + 100);

        Thread.sleep(100);
        if (threadSuspended) {
          synchronized(this) {
            while (threadSuspended)
              wait();
          }
        }
        } catch(InterruptedException e) {}
    }
  }

  public void start()
   {
     count = 0;
     if(runner != null)
     {
       threadSuspended = false;
       runner.interrupt();
       runner = null;
     }
     runner = new Thread(this);
     runner.start();

   }

   public synchronized void actionPerformed(ActionEvent e)
   {

     if(e.getSource() instanceof JRadioButton)
     {
       JRadioButton rb = (JRadioButton)e.getSource();
       String dName = (String)rb.getActionCommand();
       canvas.getGraphics().clearRect(0,0, canvas.getWidth(), canvas.getY());
       if(dName.equals("undeterministic")){
         ctrlMain.remove(ctrlPanel);
         ctrlMain.add(ctrlPanel1, BorderLayout.CENTER);
         canvas.stop();
       }
       else{
         ctrlMain.remove(ctrlPanel1);
         ctrlMain.add(ctrlPanel, BorderLayout.CENTER);
       }
       try{
         Thread.sleep(1000);
       } catch(InterruptedException e1){;}
       start();


     }

     // Handle button events
     else if(e.getSource() instanceof Button)
     {
       String actionCommand = e.getActionCommand();
       if("PAUSE".equals(actionCommand))
       {
         threadSuspended = true;
         jbStop.setActionCommand("RESUME");
         jbStop.setLabel("RESUME");

       }
       else if("RESUME".equals(actionCommand))
       {
         threadSuspended = false;
         jbStop.setActionCommand("PAUSE");
         jbStop.setLabel("PAUSE");
         notify();
       }

     }
   }

   public boolean handleEvent (Event evt) {
    switch (evt.id) {
    case Event.SCROLL_LINE_UP:
    case Event.SCROLL_LINE_DOWN:
    case Event.SCROLL_PAGE_UP:
    case Event.SCROLL_PAGE_DOWN:
    case Event.SCROLL_ABSOLUTE:
      if(evt.target == slowdown)
       jlsd.setText("Slowdown: " + getSlowdown());
      else if(evt.target == arrival)
        jlar.setText("Arrival: " + getArrival());
      else if(evt.target == lambda)
       jlmd.setText("lambda: " + getLambda());
      else if(evt.target == enterRate)
        jler.setText("Enter Rate: " + getEnterRate());
      else if(evt.target == leaveRate)
        jllr.setText("Exit Rate: " + getLeaveRate());
    }

    return true;
   }
   public Panel addPanel(){
     //move these to another class
     slowdown = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, 100);
     slowdown.setUnitIncrement(10);
     slowdown.setValue(10);

     arrival = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, 100);
     arrival.setUnitIncrement(10);
     arrival.setValue(50);

     changelane = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, 100);
     changelane.setUnitIncrement(10);
     changelane.setValue(10);

     lambda = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, 100);
     lambda.setUnitIncrement(10);
     lambda.setValue(100);

     Panel p2 = new Panel();
     p2.setSize(150, 250);
     p2.setLayout(new GridLayout(8, 1));
     p2.add(new Label(""));
     jlsd = new Label("Slowdown: " + getSlowdown());
     p2.add(jlsd);
     p2.add(slowdown);
     jlar = new Label("Arrival: " + getArrival());
     p2.add(jlar);
     p2.add(arrival);
     jlmd = new Label("lambda: " + getLambda());
     p2.add(jlmd);
     p2.add(lambda);
     p2.add(new Label(""));

     return p2;
   }

   public Panel addPanel1(){
     //move these to another class
     enterRate = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, 100);
     enterRate.setUnitIncrement(10);
     enterRate.setValue(50);
     leaveRate = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, 100);
     leaveRate.setUnitIncrement(10);
     leaveRate.setValue(50);

     Panel p2 = new Panel();
     p2.setSize(150, 250);
     p2.setLayout(new GridLayout(8, 1));
     p2.add(new Label(""));
     jler = new Label("Enter Rate: " + getEnterRate());
     p2.add(jler);
     p2.add(enterRate);
     jllr = new Label("Exit Rate: " + getLeaveRate());
     p2.add(jllr);
     p2.add(leaveRate);

     return p2;
   }


   //get the probability os slowdown from scrollbar
   public double getSlowdown()
   {
     return 0.01 * slowdown.getValue();
   }

   //get the probability of arrival from scrollbar
   public double getArrival()
   {
     return 0.01 * arrival.getValue();

   }

   //get the probability of a car changing lane.
   //if failed, increase speed.
   public double getChangeLane()
   {
     return 0.01 * changelane.getValue();
   }

   public double getLambda()
   {
     return 0.01 * lambda.getValue();
   }
   public double getEnterRate()
   {
     return 0.01 * enterRate.getValue();
   }
   public double getLeaveRate()
   {
     return 0.01 * leaveRate.getValue();
   }


}


class RoadCanvas extends Canvas
{

   private final int DOTSIZE = 2;
   private final int XDOTDIST = 2;
   private Road freeway;
   private NdRoad nfreeway;
   private Image buffer;
   private int iSelected;
   private int[] previousRules;
   private int row;
   private int xsize;
   private int ysize;
   private double density;
   private double deltaX;

   public RoadCanvas(double density, double deltaX)
   {
      freeway = new Road(density, deltaX);
      nfreeway = new NdRoad(density, deltaX);
      row = 0;
      this.density = density;
      this.deltaX = deltaX;
   }

   public void update(double enterRate, double leaveRate)
   {
       nfreeway.update(enterRate, leaveRate);
       //previousRules = nfreeway.getPreviousRules();
       if (buffer == null)
       {
         xsize = getSize().width;
         ysize = getSize().height;
         buffer = createImage(xsize, ysize);
       }
       //buffer the previous image.
       Graphics bg = buffer.getGraphics();
       nfreeway.paint(bg, row, XDOTDIST, DOTSIZE, 0);
       if (row < ysize - 2 * DOTSIZE + 1)
         row += DOTSIZE;
       else
       {
         //scrolling up effect
         bg.copyArea(0, DOTSIZE, xsize, ysize - DOTSIZE, 0, -DOTSIZE);
         bg.clearRect(0, ysize - DOTSIZE, xsize, DOTSIZE);
       }
       bg.dispose();
       repaint();
   }

   public void update(double slowdown, double arrival, double lambda, double changelane)
   {
     //updates the road
     //previousRules = freeway.getPreviousRules();
     freeway.update( slowdown, arrival, lambda, changelane);

     if (buffer == null)
     {
       xsize = getSize().width;
       ysize = getSize().height;
       buffer = createImage(xsize, ysize);
     }
     //buffer the previous image.
     Graphics bg = buffer.getGraphics();
     freeway.paint(bg, row, XDOTDIST, DOTSIZE, 0);
     if (row < ysize - 2 * DOTSIZE + 1)
       row += DOTSIZE;
     else
     {
       //scrolling up effect
       bg.copyArea(0, DOTSIZE, xsize, ysize - DOTSIZE, 0, -DOTSIZE);
       bg.clearRect(0, ysize - DOTSIZE, xsize, DOTSIZE);
     }
     bg.dispose();
     repaint();
   }

   public void paint(Graphics g)
   {
     if (buffer != null)
       g.drawImage(buffer, 0, 0, null);
   }

   public void update(Graphics g)
   {
     paint(g);
   }

   public void stop()
   {
     //this.getGraphics().fillRect (0, 0, this.getWidth(), this.getHeight());
     this.getGraphics().dispose();
     previousRules = freeway.getPreviousRules();
     nfreeway.setPreviousRules(previousRules);
     row = 0;

   }


}




