

import java.awt.*;
import java.awt.event.*;
import javax.swing.JComponent;
import javax.swing.*;


class RoadCanvas extends Canvas
{

   private final int DOTSIZE = 2;
   private final int XDOTDIST = 2;
   private Road freeway;
   private Image buffer;
   private int row;
   private int xsize;
   private int ysize;

   public RoadCanvas(double density, double deltaX)
   {
      freeway = new Road(density, deltaX);
      row = 0;
   }

   public void update(double slowdown, double arrival, double lambda, double changelane)
   {
     //updates the road
      freeway.update( slowdown, arrival, lambda, changelane);
      if (buffer == null)
      {
         xsize = getSize().width;
         ysize = getSize().height;
         buffer = createImage(xsize, ysize);
      }
      //buffer the previous image.
      Graphics bg = buffer.getGraphics();
      freeway.paint(bg, row, XDOTDIST, DOTSIZE, 0);
      if (row < ysize - 2 * DOTSIZE + 1)
         row += DOTSIZE;
      else
      {
        //scrolling up effect
         bg.copyArea(0, DOTSIZE, xsize, ysize - DOTSIZE, 0, -DOTSIZE);
         bg.clearRect(0, ysize - DOTSIZE, xsize, DOTSIZE);
      }
      bg.dispose();
      repaint();
   }

   public void paint(Graphics g)
   {
      if (buffer != null)
         g.drawImage(buffer, 0, 0, null);
   }

   public void update(Graphics g)
   {
      paint(g);
   }


}